/*
 *  Gtk_CoordBox.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef GTK_COORDBOX_H 
#define GTK_COORDBOX_H 

#include <gtk--.h>
#include "state.h"
#include "Gtk_HEntryScale.h"
#include "Gtk_CoordBox_state.h"

class Gtk_CoordBox : public Gtk_Frame {

private:

    Gtk_VBox *box;
    Gtk_HBox *button_box;
    Gtk_HEntryScale *x;
    Gtk_HEntryScale *y;
    Gtk_HEntryScale *z;
    Gtk_CheckButton *constrain;
    bool constrained;
    
public:

    Gtk_Button *revert;

    class Gtk_CoordBox_State * state;
    
    Signal0 changed;
    Gtk_CoordBox(Gtk_CoordBox_State * _state);
/*     void reset_bounds(double x_minval, double x_maxval, double x_currval, */
/* 		      double y_minval, double y_maxval,	double y_currval, */
/* 		      double z_minval, double z_maxval, double z_currval); */
    double getVal(int which);
    void toggle_constrain();
    void revert_values();
};
 
#endif
