/*
 *  Gtk_HEntryScale.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */

#include <stdio.h>
#include <math.h>
#include "Gtk_HEntryScale.h"
#include "fractal.h"

Gtk_HEntryScale::Gtk_HEntryScale(Gtk_HEntryScale_State * _state) {
    state = _state;
    res = state->res;

    //    printf("GTK_HentryScale this = %d\n");
    label = new Gtk_Label(state->label);

    if(state->log) {
	adj = new Gtk_Adjustment(log(state->val), 
    				 log(state->minval),
    				 log(state->maxval), state->res, state->res, state->res);
 	printf("setting minval to %.2f, maxval to %.2f, val to %.2f\n",
 	       log(state->minval), log(state->maxval), log(state->val));
     } else
	adj = new Gtk_Adjustment(state->val, state->minval, state->maxval, state->res, state->res, state->res);
    scale = new Gtk_HScale(adj);

    scale->set_digits(1.0);

    connect_to_method(adj->value_changed, this, &Gtk_HEntryScale::setEntry);
//    connect_to_method(entry.changed, this, &Gtk_HEntryScale::setScale);

    pack_start(label, TRUE, TRUE, 2);
    pack_start(scale, TRUE, TRUE, 2);
    pack_start(&entry, FALSE, TRUE, 2);

    scale->set_usize(100, 20);
    scale->set_draw_value(FALSE);
    entry.set_usize(40, 20);

    label->show();
    scale->show();
    entry.show();

    adj->value_changed();
    show();
}
				// sets entry from scale
void Gtk_HEntryScale::setEntry() {

    char buf[30];
    double val = adj->get_value();
    if(state->log) {
// // 	printf("val is %.2f ", val);
  	val = exp(val);
// // 	printf("val is %.2f\n", val);
// // 	printf("was log at %p\n", state);
    }
    val -= fmod(val,res);
    sprintf(buf, "%.2f", val);
    entry.set_text(strdup(buf)); // this probably leaks some memory..
}

void Gtk_HEntryScale::setVal(double val) {

//    printf("setVal: %.2f\n", val);
    if(state->log)
   	val = log(val);

    adj->set_value(val);
    setEntry();
    scale->default_hslider_update();
}

void Gtk_HEntryScale::setAdjustment(Gtk_Adjustment *_adj) {

    gtk_object_unref(GTK_OBJECT(adj->gtkobject));
//    adj->unref();
//    printf("fucking ducks\n");
    scale->set_adjustment(adj = _adj);
    gtk_object_ref(GTK_OBJECT(adj->gtkobject));
    connect_to_method(adj->value_changed, this, &Gtk_HEntryScale::setEntry);
    adj->value_changed();
    //scale->slider_update();
}
				// sets scale from entry
void Gtk_HEntryScale::setScale() {

    double val = strtod(entry.get_text(), NULL);
//     if(state->log)
// 	val = log(val);
	
    adj->set_value(val);
}


void Gtk_HEntryScale::reset(double min, double max, double newval) {

    double res = GTK_ADJUSTMENT(adj->gtkobject)->step_increment;
    printf("NOOO!!!!!!\n");
    gtk_object_unref(GTK_OBJECT(adj->gtkobject));
    adj = new Gtk_Adjustment(newval, min, max, res, 0, 0);
    scale->set_adjustment(adj);
    gtk_object_unref(GTK_OBJECT(adj->gtkobject));
//    adj->unref();
    connect_to_method(adj->value_changed, this, &Gtk_HEntryScale::setEntry);
    adj->value_changed();
}

double Gtk_HEntryScale::getVal() {
    double val = adj->get_value();
//    printf("val is %.2f in getval\n", val);
    if(state->log)
  	val = exp(val);
//    printf("getval returning %.2f\n", val);
    return val;
}

double Gtk_HEntryScale::getRes() {
    return GTK_ADJUSTMENT(adj->gtkobject)->step_increment;
}

double Gtk_HEntryScale::getMinval() {
    double val = GTK_ADJUSTMENT(adj->gtkobject)->lower;
//     if(state->log)
// 	val = exp(val);
   return val;
}

double Gtk_HEntryScale::getMaxval() {
    double val = GTK_ADJUSTMENT(adj->gtkobject)->upper;
//     if(state->log)
// 	val = exp(val);
    return val;
}
