/*
 *  Gtk_HEntryScale.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef GTK_HENTRY_SCALE_H
#define GTK_HENTRY_SCALE_H

#include <gtk--.h>
#include <string.h>
#include "state.h"
#include "Gtk_HEntryScale_state.h"

class Gtk_HEntryScale : public Gtk_HBox {

private:
    
    Gtk_Label *label;
    Gtk_Adjustment *adj;
    Gtk_HScale *scale;
    Gtk_Entry entry;
    double res;

public:

    
    class Gtk_HEntryScale_State * state;

    Gtk_HEntryScale(class Gtk_HEntryScale_State * _state);
    void setVal(double val);
    void setRange(double minval, double maxval);
    void setAdjustment(Gtk_Adjustment *_adj);
    Gtk_Adjustment * getAdjustment() {return adj;}
    void setResolution(double res);
    void reset(double min, double max, double newval);
    void setEntry();
    void setScale();
    void update() {scale->draw_trough();}
    double getVal();
    double getRes();
    double getMinval();
    double getMaxval();
    double getSmallStep();
};

#endif
