/*
 *  Gtk_HEntryScale_state.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */

#include "Gtk_HEntryScale_state.h"

Gtk_HEntryScale_State::Gtk_HEntryScale_State(): entry(NULL) {}
	
void Gtk_HEntryScale_State::save(FILE * fp) {
    fprintf(fp, "%s\n%.5f %.5f\n%.5f\n%.5f\n%.5f\n%d\n", 
	    label, minval, maxval, val, res, small_step, log);
}
void Gtk_HEntryScale_State::load(FILE * fp) {
    char buf[100];
    double v[6];
    fscanf(fp, " %s ", buf);
    fscanf(fp, " %lf %lf %lf %lf  %lf ", v, v+1, v+2, v+3, v+4, v+5);
    printf("---------\n");
    for(int i = 0 ; i < 4 ; i++)
	printf("%.5f ", v[i]);
    printf("\n");
    //    fscanf(fp, " %lf %lf %lf %lf ", &minval, &maxval, &val, &res);
    minval = *v;	// tad gorey
    maxval = v[1];
    val = v[2];
    res = v[3];
    small_step = v[4];
    log = (bool)v[5];
    printf("%s %lf %lf %lf %lf\n", buf, minval, maxval, val, res);
    label = strdup(buf); // should probably free this somewhere 
    printf("Gtk_HENTRY_SCALE: this = %p label = %s\n", this, label);
}
// bool operator !=(State & other) {
//     return(label != other.label ||
// 	   val != other.val ||
// 	   minval != other.minval ||
// 	   maxval != other.maxval ||
// 	   res != other.res ||
// 	   entry != other.entry);
// }
void Gtk_HEntryScale_State::alloc() {
    entry = new Gtk_HEntryScale(this);
}
float Gtk_HEntryScale_State::value() { 
    return val;
//	    pushed ? val : entry->getVal();
}
float Gtk_HEntryScale_State::gui_value() {
  //    assert(entry);
    return entry ? entry->getVal() : val;
}
void Gtk_HEntryScale_State::apply() {
    if(entry)
	entry->setVal(val);
}
void Gtk_HEntryScale_State::grab() {
    if(entry)
	val = entry->getVal();
}
bool Gtk_HEntryScale_State::changed() {
    return(entry && entry->getVal() != val);
}
	    
