#include "MenuFactory.h"

MenuFactory::MenuFactory(GtkMenuFactoryType type) : Gtk_MenuFactory(type) 
{}

Gtk_MenuItem* MenuFactory::add_entry(char *path,
				     char *accelerator,
				     void (*target_func)(void))
{
  static GtkMenuEntry entry = { NULL, NULL, NULL, NULL, NULL };
  Gtk_MenuItem *entry_widget;
  
  entry.path = path;
  entry.accelerator = accelerator;
  
  add_entries(&entry, 1);

  entry_widget = new Gtk_MenuItem((GtkMenuItem*)entry.widget);

  if(target_func)
    connect_to_signal(entry_widget->activate, target_func);
  
  return entry_widget;
  
}

// broken g++ stub
template <class T>
Gtk_MenuItem* menu_factory_add_entry(MenuFactory *This, char *path,
				     char *accelerator,
				     T *target_widget,
				     void (T::*target_method)(char*),
				     char *data)
{
  static GtkMenuEntry entry = { NULL, NULL, NULL, NULL, NULL };
  Gtk_MenuItem *entry_widget;
  
  entry.path = path;
  entry.accelerator = accelerator;
  
  This->add_entries(&entry, 1);
  
  entry_widget = new Gtk_MenuItem((GtkMenuItem*)entry.widget);
  
  connect(entry_widget->activate,
	  target_widget, target_method, data);
  
  return entry_widget;
  
}  
