/*
 *  bitvect.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef BITVECT_H
#define BITVECT_H

#include <stdio.h>
#include <string.h>
#include <semaphore.h>

// efficiently stores a three dimensional array of bit records
// sizeof(char) is assumed to be 8 bits

// individual records are accessed through the first byte of an int,
// which limits the maximum size of a record to somewhere around 24 bits

class bitvect {

private:
    int max_a, max_b, max_c;	// three dimensions
    int size_each;		// bits
    sem_t mutex;

public:

    char * data;

    bitvect(int a, int b, int c, int _size_each);
    ~bitvect();

    bool get(int a, int b, int c, int bit);
    void set(int a, int b, int c, int bit, bool val);

};



#endif
