/*
 *  defs.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DEFS_H
#define DEFS_H

#define YYSTYPE expr_ref

#define WIRE 0
#define FLAT 1
#define SMOOTH 2

#ifdef USE_THREADS
#define _REENTRANT
#endif

#include <stdlib.h>     
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <assert.h>

#include <X11/keysym.h>

#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>

#include <gtk--.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

extern "C" {
#include <gdk/gdkx.h>
}

#ifdef USE_THREADS
#include <pthread.h>
#endif

#include "quat.h"
#include "stack.h"
#include "expr_tree.h"
#include "expr_parser.h"
#include "light.h"
#include "bitvect.h"
#include "fract_view.h"

extern void refresh_browser();
extern void refresh();
extern float max(float n1, float n2);
extern float max_abs(float n1, float n2);
extern int match(int);
extern void yyerror(const char *);

#define X 0
#define Y 1
#define Z 2
#define W 3

extern int yylex();

//extern "C" int yylex(void);

extern int yyparse();
extern int yydebug;
extern int yy_flex_debug;

extern YYSTYPE yylval;
extern expr_ref tree_top;	/* declared in expr_parser.y */

#endif

