#ifndef EQ_TABLE_H
#define EQ_TABLE_H

#include "expr_tree.h"

class eq_table {

private:

    class Entry {
    public:
	class Prop {
	public:
	    int rule, dep1, dep2;	    
	};

	double vect[4];		// actual values
	Prop props[4];
	int index;
	Entry * next;
	expr_ref expr;
	bool skip;

	Entry(): next(0) {}
	Entry(Entry*);
    };
    
    int max_iter;
    double max_val;
    
    Entry * table_list;
    Entry ** table;
    int index_of_last_column;
    int q_index;		// index of dependent variable
    int c_index;		// index of c (position specific constant)

    bool q_is_c_initially;
    double init_q_val[4];

    int add_column(expr_ref expr);

public:

    eq_table(eq_table*);
    eq_table(expr_ref expr, int max_iter, double max_val);
    double iter(double, double, double, double, int &);
    double mag();
    void eval();
    void set_init_q_val(double * v);
    void set_q_to_c_initially();

};

#endif
