 
%{
#include "expr_tree.h"
#include "defs.h"
expr_ref tree_top;
%}


%token '^' '*' '/' '+' '-' TOK_LIT_QUAT 'q' 'i' 'j' 'k' 'e' TOK_LIT_PI '(' ')' TOK_LIT_SCALAR

%left LOWEST
%left NEAR_LOWEST
%left ')'
%left '-' '+'
%left '*' '/'
%right '^'
%right HIGHEST

%start s

%%

s:  expr                       { tree_top = $1; }

expr:  
     | either                      { $$ = $1; } %prec LOWEST

quat_expr:  '(' expr ')'       { $$ = $2; }
          | quat_expr '^' tight_scalar  { $$ = $2->set_children($1, $3); }
          | scalar_expr '^' quat_expr   { $$ = $2->set_children($1, $3); }
          | 'q'                     { $$ = $1; }
          | 'i'                     { $$ = $1; }
          | 'j'                     { $$ = $1; }
          | 'k'                     { $$ = $1; } 
          | 'c'                     { $$ = $1; }
          | TOK_LIT_QUAT            { $$ = $1; }

scalar_expr: 
        scalar_expr '*' scalar_expr { $$ = $2->set_children($1, $3); }
     |  scalar_expr '+' scalar_expr      { $$ = $2->set_children($1, $3); }
     |  scalar_expr '-' scalar_expr      { $$ = $2->set_children($1, $3); }
     |  scalar_expr '/' scalar_expr      { $$ = $2->set_children($1, $3); }
     |  scalar_expr '^' scalar_expr      { $$ = $2->set_children($1, $3); }
     |  tight_scalar

tight_scalar:
       '(' scalar_expr ')'               { $$ = $2; } %prec NEAR_LOWEST
     | 'e'                               { $$ = $1; }
     | TOK_LIT_PI                        { $$ = $1; }
     | TOK_LIT_SCALAR                    { $$ = $1; }

either:either '*' either           { $$ = $2->set_children($1, $3); }
     | either '+' either           { $$ = $2->set_children($1, $3); }
     | either '-' either           { $$ = $2->set_children($1, $3); }
     | either '/' scalar_expr      { $$ = $2->set_children($1, $3); }
     | quat_expr { $$ = $1; }
     | scalar_expr { $$ = $1; } %prec LOWEST

%%

void yyerror(const char * message) {
    fprintf(stderr, message);
}

