/*
 *  expr_tree.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef EXPR_TREE_H
#define EXPR_TREE_H

#include "quat.h"

typedef class Expr_Tree * expr_ref;

class Expr_Tree {

private:
    
public:

    expr_ref lchld, rchld;	// tree pointers
    char * data;
    int token_code;
    quat * val;
    double scalar_val;
    bool scalar;
    bool constant;

    expr_ref set_children(expr_ref, expr_ref);
    Expr_Tree(char *, int);
    ~Expr_Tree();
    void setVal(quat * q) { val = q; }
    void setVal(double s) { scalar_val = s; }
    void dump();
    bool eql(Expr_Tree *);
    Expr_Tree * copy();
    static expr_ref load(FILE * file);
    void save(FILE * file);
    char * make_string();
    void set_scalar() { scalar = true; }
    void set_constant() { constant = true; }
};

#endif

