#include "bitvect.h"
#include <assert.h>

bitvect::bitvect(int a, int b, int c, int _size_each) {
    max_a = a;
    max_b = b;
    max_c = c;
    size_each = _size_each;
    data = new char[(max_a*max_b*max_c*size_each+7)>>3];
    bzero(data, (max_a*max_b*max_c*size_each+7)>>3);
#ifdef USE_THREADS
    assert(!sem_init(&mutex, 0, 1));
#endif
    printf("bitvect size is %d bytes\n",(max_a*max_b*max_c*size_each+7)>>3);
}
  
bitvect::~bitvect() {
#ifdef USE_THREADS
    sem_wait(&mutex);
#endif
    delete[] data;
}

bool bitvect::get(int a, int b, int c, int bit) {
    int idx = a*size_each*max_c*max_b + b*size_each*max_c + c*size_each;
#ifdef USE_THREADS
    sem_wait(&mutex);
#endif
    bool ans = (*(int *)(data+(idx>>3))) & 1 << ((idx&7)+bit);
//    printf("in get data = %p\n");
#ifdef USE_THREADS
    sem_post(&mutex);
#endif
    return(ans);
}
    
void bitvect::set(int a, int b, int c, int bit, bool val) {
    int which = a*size_each*max_c*max_b + b*size_each*max_c + c*size_each;
#ifdef USE_THREADS
    sem_wait(&mutex);
#endif
    if(val) 
	(*(int *)(data+(which>>3))) |= 1 << ((which&7)+bit);
    else 
	(*(int *)(data+(which>>3))) &= ~(1 << ((which&7)+bit));
//    printf("in set data = %p\n");
#ifdef USE_THREADS
    sem_post(&mutex);
#endif
}
