/*
 *  neibhors.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "fractal.h"

// this one's pretty heinous 
// (compliling it takes long enough that it's in its own file..)

coordList * fractal::enumerateNeibhors(int a, int b, int c, int d) {

    coordList * neibhors = NULL;

    // there can be as many as 80 neibhors (3^4-1) for any given point
    // if the point in question is next to some sort of boundary then
    // we don't want all those neibhors.  Following is a ternary search
    // for which situation we are in.  Lots of code but only 12 conditionals max

    // note:  we don't need to test d because we always generate divergence info
    // for d, d+1 and d-1

    if(a == 0) {		
	if (b == 0) {		 
	    if( c == 0 ) {	//  a == 0 b == 0 c == 0 

		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { // a == 0 b == 0 c == size 

		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));

	    } else {	// a == 0 b == 0
    
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));
	    }
	} else if( b + 1 == state->gui.size.y.value()  ) {	
	    if( c == 0 ) {	 // a == 0 b == size c == 0 

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { // a == 0 b == size c == size

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));

	    } else {	// a == 0 b == size 
		    
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));

	    }
	} else {		
	    if( c == 0 ) {	// a == 0 c == 0 

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { // a == 0 c == size
    
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));

	    } else {	// a == 0

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));
	    }
	}
    } else if( a + 1 == state->gui.size.x.value() ) {
	if (b == 0) {		 
	    if( c == 0 ) {	//  a == size b == 0 c == 0 

		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { // a == size b == 0 c == size 

		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));

	    } else {	// a == size b == 0
    
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
	    }

	} else if( b + 1 == state->gui.size.y.value()  ) {	
	    if( c == 0 ) {	// a == size b == size c == 0 

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() )  {// a == size b == size c == size

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));

	    } else {	// a == size b == size 
		    
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
	    }

	} else {		
	    if( c == 0 ) {	// a == size c == 0
		    
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { 	// a == size c == size
    
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));

	    } else {	// a == size

		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
	    }
	}

    } else {
	if (b == 0) {		 
	    if( c == 0 ) {	//  b == 0 c == 0  

		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) {//  b == 0 c == size 

		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));

	    } else {	// b == 0
    
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));
	    }
	} else if( b + 1 == state->gui.size.y.value()  ) {	
	    if( c == 0 ) {	//  b == size c == 0  

		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) {	//  b == size c == size 
		
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		    
	    } else {	// b == size
	      
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));
	    }
	} else {
	    if( c == 0 ) {	//   c == 0 

		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));

	    } else if( c + 1 == state->gui.size.z.value() ) { //   c == size 

		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));

	    } else {	// everybody..
		        
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a-1, b+1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b-1, c+1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c-1, d+1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d-1));
		neibhors = neibhors->prepend(new coordList(a+1, b+1, c+1, d+1));
	    }
	}
    }
    return neibhors;
}


