/*
 *  stack.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "defs.h"

void stack::push(quat * q) {
    if(top - s< size) {
	*top = q;
	++top;
    } else {
	fprintf(stderr, "stack overflow in s\n");
	exit(-1);
    }
}

quat * stack::pop() {

    if(top - s> 0)
	return(*--top);
    else {
	fprintf(stderr, "stack underflow in s\n");
	exit(-1);
    }
    return((quat *)0);		// damn sgi CC..
}

stack::stack(int _size) {
    size = _size;
    s = new quat *[size];
    top = s;
}


