/*
 *  fract_rot.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef FRACT_ROT_H
#define FRACT_ROT_H

#include <gtk--.h>
#include "radial_positioner.h"
#include "positioner.h"
#include "state.h"
#include "fract_rot_state.h"

class Fract_Rot : public Gtk_VBox {

private:

    Gtk_VScale *zoom;
    Gtk_CheckButton *perspective;
    Gtk_VBox *vbox;
    Gtk_HBox *hbox;
    class fractal * fract;

    bool perspective_mode;

    void set_perspective();
    void set_zoom();
    
    double zoom_val;

    Connection rot_sig;
    bool connected;

public:
    void detach_signals();
    void attach_signals(Signal0 *signal);

    Gtk_Adjustment *zoom_adj;

    class Fract_Rot_State *state;

    class Positioner *rot;
    
    Fract_Rot(class Fract_Rot_State *);
};


#endif
