/*
 *  fract_view.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef VIEW_H
#define VIEW_H

#include <gtk--.h>
#include "radial_positioner.h"
#include "positioner.h"
#include "state.h"
#include "fract_view_state.h"
#include "math.h"

class Fract_View : public Gtk_VBox {

private:

    Gtk_VScale *zoom;
    Gtk_CheckButton *perspective;
    Gtk_VBox *vbox;
    Gtk_HBox *hbox;
    class fractal * fract;

    bool perspective_mode;

    void set_perspective();
    void set_zoom();
    
    double zoom_val;
    
    Gtk_Adjustment *zoom_adj;

    Connection rot_sig;
    Connection persp_sig;
    Connection zoom_sig;

    bool connected;

public:

    class Fract_View_State * state;

    class Positioner *rot;
//    Gtk_RadialPositioner rot;
    
    Fract_View(class Fract_View_State *);
    void compute_projection();
    double get_zoom_val() { return(exp(zoom_adj->get_value()));}
    void detach_signals();
    void attach_signals(Signal0 *signal);
};


#endif
