#include "fract_view_state.h"

Fract_View_State::Fract_View_State() {
    add_child(&rot);
}

void Fract_View_State::load(FILE * fp) {
    fscanf(fp, " %f  %f  %f %d ", &zoom_val, 
	   &min_zoom, &max_zoom, &perspective_on);
    rot.load(fp);
}

void Fract_View_State::save(FILE * fp) {
    fprintf(fp, "%.5f %.5f %.5f %d\n", zoom_val,
	    min_zoom, max_zoom, perspective_on);
    rot.save(fp);
}

void Fract_View_State::set_default() { 
    zoom_val = 1.0;
    min_zoom = .1;
    max_zoom = 10;
    perspective_on = true;
    rot.xpos = 0;
    rot.ypos = 0;
}

Fract_View * Fract_View_State::create_gui() {
    printf("creating new Fract_View: %p\n", this);
    return view = new Fract_View(this);
}
// bool operator !=(State & other) {
//     return(zoom_val != other.zoom_val ||
// 	   perspective_on != other.perspective_on ||
// 	   view != other.view ||
// 	   rot != other.rot);
// }
double Fract_View_State::get_zoom_val() {
//	    assert(view);
    //	    printf("view = %p\n", view);
    if(view == NULL)
	return zoom_val;
    else
//	return GTK_ADJUSTMENT(view->zoom_adj->gtkobject)->value;
	return view->get_zoom_val();
}
