#include "fractal_state.h"
#include <stdio.h>
				// resets state in fractal
fractal_State::fractal_State() {
    add_child(&gui);
    add_child(&lw);
    filename = 0;
}

void fractal_State::load(const char * path) {
    filename = strdup(path);
    FILE * fp = fopen(filename, "r");
    set_name_from_filename(filename);
    if(fp) {
	::State::load(fp);
	fclose(fp);
    }
}

void fractal_State::set_name_from_filename(char * filename) {
    char * fist = strrchr(filename, '/');
    if(fist) 
	name = strdup(fist);
    else
	name = strdup(filename);
}

void fractal_State::set_default() {
    ::State::set_default();
    name = strdup("default");
}

void fractal_State::save() {		// need to pop up gui if no filename
    FILE * fp = fopen(filename, "w");
    if(fp) {
	::State::save(fp);
	fclose(fp);
    }
    printf("saved\n");
}

void fractal_State::show_fractal() {
    lw.model.fract = lw.view.fract = lw.light.fract = gui.fract = fract = new fractal(this);
}
