/*
 *  hash.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "hash.h"
#include <stdio.h>
#include <string.h>

int Hash::Hashpwj(char * s) {
    char * p;
    unsigned h = 0, g;

    for ( p = s ; *p != '\0' ; p++ ) {
	h = ( h << 4 ) + *p;
	if (g = h & 0xf0000000) {
	    h = h ^ ( g >> 24 );
	    h = h ^ g;
	}
    }
    return h % size;
}

bool Hash::enter( char * string ) {
    
    int hashval = Hashpwj(string);
    String_node * list = table[hashval];
    String_node * new_node;

    while ( list != NULL ) {	// first look for string in Hash
	if (strcmp(string, list->string)==0)
	    return false;
	list = list->next;
    }
				// string not found
    new_node = new String_node;
    new_node->string = strdup(string);
    new_node->next = table[hashval];
    table[hashval] = new_node;
    
    return(true);
}

void Hash::clear() {
    
    for(int i = 0 ; i < size ; i++) {
	delete table[i];
	table[i] = NULL;
    }
}

