/*
 *  hash.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HASH_H
#define HASH_H

#include <stdio.h>

class String_node {

public:

    char * string;
    struct String_node * next;

    String_node(): string(0), next(0) {}

    ~String_node() {
	if(string)
	    delete [] string;
	if(next)
	    delete(next);
    }
};

class Hash {
    
private:

    String_node ** table;
    int size;
    int Hashpwj(char * data);

public:

    bool enter( char * string );
    void clear();
    
    Hash(int _size): size(_size) {
	table = new String_node * [size];
	for(int i = 0 ; i < size ; i++)
	    table[i] = 0;
    }

    ~Hash() {
	for(int i = 0 ; i < size ; i++)
	    if(table[i])
		delete table[i];
    }

};

#endif // HASH_H
