/*
 *  light.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "fractal.h"

#define W 3

Light::Light(Light_State * _state) {

//     radius = _radius;
//     rot_x = _rot_x;
//     rot_y = _rot_y;
    state = _state;
    
    rot = new Positioner(100, 100);
//    rot->set_usize(100,100);
    adj = new Gtk_Adjustment(log(state->radius),
			     log(state->min_rad),
			     log(state->max_rad),
			     0.1, 0.1, 0.1);
    scale = new Gtk_VScale(adj);
    on = new Gtk_CheckButton("on");
    hbox = new Gtk_HBox(False, 0);
    vbox = new Gtk_VBox(False, 0);

    gtk_widget_set_events(GTK_WIDGET(rot->gtkobject),
			  GDK_BUTTON_PRESS_MASK | 
			  GDK_BUTTON_RELEASE_MASK |
			  GDK_EXPOSURE_MASK | 
			  GDK_BUTTON_MOTION_MASK);

    hbox->pack_start(rot, TRUE, TRUE, 0);
    hbox->pack_start(scale, TRUE, TRUE, 0);
    vbox->pack_start(hbox, TRUE, TRUE, 0);
    vbox->pack_start(on, TRUE, TRUE, 0);
    add(vbox);
    
    rot->show();
    scale->show();
    on->show();
    hbox->show();
    vbox->show();
//    show();

    state->rot.pos = rot;
    
    connect_to_signal(rot->changed, state->fract->refresh);
    connect_to_signal(adj->value_changed, state->fract->refresh);
    connect_to_method(on->toggled, this, &Light::toggle_on);
    //    if(state->fract)
    connect_to_signal(on->toggled, state->fract->refresh);

}

void Light::toggle_on() {
    state->on = !state->on;
}



