/*
 *  light.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef LIGHT_H
#define LIGHT_H

#include <stdio.h>

#include "positioner.h"
#include "state.h"

#include <GL/gl.h>

#include <gtk--.h>


#define X 0
#define Y 1
#define Z 2
#define W 3

#define LSIZE 1;

#include "light_state.h"

class Light : public Gtk_VBox {

    Gtk_VScale *scale;
    Gtk_Adjustment * adj;
    Gtk_CheckButton *on;
    Gtk_HBox *hbox;
    Gtk_VBox *vbox;

//    class fractal * fract;

public:

    class Positioner *rot;

    class Light_State * state;

    friend class Light_State;

    Light(Light_State * _state);
    void toggle_on();
    void draw();
//    void set_radius(double _radius) { radius = _radius; }

};


#endif // LIGHT_H
