#ifndef LIGHT_STATE_H
#define LIGHT_STATE_H

#include "light.h"
#include "positioner.h"

class Light_State : public ::State {
    
private:

public:

    class Light * light;
    class fractal * fract;
	
    bool changed;
    float radius;
    float min_rad, max_rad;
    bool on;

    class Positioner::State rot;

    GLfloat mat_amb[4];
    GLfloat mat_dif[4];
    GLfloat mat_specular[4];
    GLfloat mat_emission[4];
    GLfloat mat_shininess[1];
	
    GLfloat db_ambient[4];
    GLfloat db_diffuse[4];
    GLfloat db_specular[4];
    GLfloat db_at[4];
	
    GLfloat ambient[4];
    GLfloat diffuse[4];
    GLfloat specular[4];
    GLfloat at[4];
    GLfloat pos[4];
	
    Light_State(): light(0), fract(0) {}

    float getRadius();
    void save(FILE * fp);
    void load(FILE * fp);
    void load_vect(GLfloat * vect, FILE * fp);
    void save_vect(GLfloat * vect, FILE * fp);
    void set_default();
    Light * create_gui();
//	void show_dialog() { light = new Light(this); }
    void apply();
    void grab();
};

#endif
