#include "listwindow.h"

StateList fractals;

list_window::list_window() {

    file_dialog = new Gtk_FileSelection("Open Fractal");
    
    top_box = new Gtk_VBox;
    buttons = new Gtk_Table(3,3,FALSE);
    list = new Gtk_List();
    list->set_usize(30,30);

    //    sc_win = new Gtk_ScrolledWindow(NULL, NULL);
    //    sc_win->set_policy(GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    //    sc_win->set_usize(100,90);
//    list->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    saving = false;

    Gtk_Button * button;

    Gtk_Button * button_array[6];    
    gchar * tooltips[] = {"Render Fractal", "Save", "Load", "View Dialog",
			  "Default Fractal", "Fractal Config"};
    gchar * pixmap_array[] = {"draw.xpm", "save.xpm", "open.xpm",
			     "rot.xpm", "default.xpm", "gears.xpm"};
    
    int pos_array[][4] = {{0,1,1,2},{1,2,0,1},{0,1,0,1},
			  {2,3,1,2},{2,3,0,1},{1,2,1,2}};

    GdkPixmap * pixmap;
    GdkBitmap * mask;
    Gtk_Pixmap * image;
    Gtk_Tooltips * tooltip;

    realize();			// need this to avoid null window errors
				// from pixmap creation

    for(int i = 0 ; i < 6 ; i++) {
	button_array[i] = new Gtk_Button;
	tooltip = new Gtk_Tooltips;
	tooltip->set_tip((Gtk_Widget*)(button_array[i]), tooltips[i], NULL);
	pixmap = gdk_pixmap_create_from_xpm(GTK_WIDGET(this->gtkobject)->
					    window, &mask,
					    &GTK_WIDGET(this->gtkobject)->
					    style->bg[GTK_STATE_NORMAL],
					    pixmap_array[i]);
	image = new Gtk_Pixmap(pixmap, mask);
	image->show();
	button_array[i]->add(image);
	buttons->attach_defaults(button_array[i], pos_array[i][0],
				 pos_array[i][1], pos_array[i][2],
				 pos_array[i][3]);
	button_array[i]->show();
    }
        
    connect_to_method(button_array[0]->clicked, this,
		      &list_window::show_fractal);
    connect_to_method(button_array[1]->clicked, this, 
		      &list_window::save_fractal);
    connect_to_signal(button_array[2]->clicked, file_dialog->show);
    connect_to_method(button_array[3]->clicked, this,
 		      &list_window::show_fractal_light);
    connect_to_method(button_array[4]->clicked, this, 
 		      &list_window::insert_default);
    connect_to_method(button_array[5]->clicked, this, 
		      &list_window::show_fractal_config);
 
    MenuFactory * factory = new MenuFactory(GTK_MENU_FACTORY_MENU);
    MenuFactory * bar_factory = new MenuFactory(GTK_MENU_FACTORY_MENU);
    menubar = new Gtk_MenuBar;
    Gtk_MenuItem * file_menu = new Gtk_MenuItem("File");
        
    factory->add_entry("save", "<control>s", this,
		     &list_window::save_current, NULL);
    factory->add_entry("delete", "<control>d", this,
		     &list_window::delete_current, NULL);
    factory->add_entry("dialogs/draw", NULL, this,
		     &list_window::draw_current, NULL);
    factory->add_entry("dialogs/view", NULL, this,
		     &list_window::view_current, NULL);
    factory->add_entry("dialogs/config", NULL, this,
		     &list_window::config_current, NULL);
    
    bar_factory->add_entry("New", NULL, this, 
			   &list_window::new_fractal, NULL);
    bar_factory->add_entry("Save", NULL, this,
			   &list_window::save_current, NULL);
    bar_factory->add_entry("Save as", NULL, this, 
			   &list_window::save_current, (char *)1);
    bar_factory->add_entry("Delete", NULL, this,
			   &list_window::delete_current, NULL);
    bar_factory->add_entry("<separator>", NULL, this, 
			   &list_window::save_current, NULL);
    bar_factory->add_entry("Quit", NULL, this, &list_window::quit, NULL);

    menu = GTK_MENU(factory->gtkobj()->widget);

    file_menu->set_submenu(bar_factory->menubar_widget());
    menubar->prepend(file_menu);

    file_menu->show();
 
    selected_state = NULL;

    //    sc_win->add(list);

    top_box->pack_start(menubar, 0, 1, 0);
    top_box->pack_start(buttons, 0, 1, 0);
    top_box->pack_start(list, 1, 1, 0);

    add(top_box);

    //    sc_win->show();
    menubar->show();
    buttons->show();
    list->show();
    top_box->show();

    connect_to_signal(file_dialog->ok_button.clicked, file_dialog->hide);
    connect_to_signal(file_dialog->cancel_button.clicked, file_dialog->hide);
    connect_to_method(file_dialog->ok_button.clicked, this, 
		      &list_window::handle_file_input);
    connect_to_method(file_dialog->cancel_button.clicked, this, 
		      &list_window::kludge);    
}

void list_window::insert_default() {
    int row;
    list_windowitem * li = new list_windowitem;

    li->lw = this;
    li->fs.set_default();
    Gtk_Label * label = new Gtk_Label(li->fs.name);
    fractals.append(&li->fs);
    li->add(label);
    label->show();
    li->show();
    li->set_usize(90,15);
    list->add(li);
    //    selected_state = &li->fs;
}

void list_window::set_state(int row, int col, GdkEventButton*) {
//    selected_state = (fractal::State*)list->get_row_data(row);
}

void list_window::unset_state(int row, int col, GdkEventButton*) {
    selected_state = NULL;
}

void list_window::save_current(char *) { 
    if(selected_state)
	if(selected_state->filename)
	    selected_state->save();
	else {
	    saving = true;
	    file_dialog->show();
	}
}

void list_window::kludge() {

    saving = false;
}


void list_window::handle_file_input() {
    
    if(saving) {
	selected_state->filename = strdup(file_dialog->get_filename());
	selected_state->save();
	saving = false;
    } else {
	load_item(file_dialog->get_filename());
    }
}

void list_window::load_item(char * file) {	// broken

//    char * file = file_dialog->get_filename();
    list_windowitem *li;
//    fractal::State *fs;
    int row;

    if(file) {
	li = new list_windowitem();
	li->load(file);
	li->lw = this;
	fractals.append(&li->fs);
	list->add(li);
	li->show();
	li->set_usize(90,15);
    }
}

void list_window::show_fractal() {
    if(selected_state)
	selected_state->show_fractal();
}

void list_window::show_fractal_config() {
    printf("selected_state = %p\n", selected_state);
    if(selected_state)
	selected_state->gui.show_dialog();
}

void list_window::show_fractal_light() {
    if(selected_state)
	selected_state->lw.show_dialog();
}

void list_window::save_fractal() {
    save_current(NULL);		// kinda  kludgy :(
}
