#ifndef LIST_WINDOW_H
#define LIST_WINDOW_H

#include <gtk--.h>
#include "fractal.h"
#include "fractal_state.h"
#include "MenuFactory.h"
#include "statelist.h"

class list_window : public Gtk_Window {

private:

    Gtk_VBox * top_box;
    Gtk_Table * buttons;
    Gtk_List * list;
    Gtk_ScrolledWindow * sc_win;
    Gtk_Button * draw_button;
    Gtk_Button * save_button;
    Gtk_Button * view_button;
    Gtk_Button * config_button;
    Gtk_Button * load_button;
    Gtk_Button * default_button;
    Gtk_FileSelection * file_dialog;

    Gtk_MenuBar * menubar;
    
    bool saving;		// not the best way..
				// menu callbacks 
    void save_current(char *);
    void save_current_as(char *) {}
    void delete_current(char *) {}
    void new_fractal(char *) {}
    void quit(char *) {Gtk_Main::instance()->quit();}
    void draw_current(char *);
    void view_current(char *);
    void config_current(char *);
    gint show_menu(GdkEventButton*);

    view_window * vw;
    Fract_Params * fpw;

    void kludge();		// make sure we keep this one private :P
    
public:    

    fractal_State * selected_state;
    GtkMenu * menu;

    list_window();
    void add_fractal(fractal_State * fs);
    void load_item(const char *);
    void handle_file_input();	// callback for file dialog;
    void insert_default();
    void set_state(int row, int col, GdkEventButton*);
    void unset_state(int row, int col, GdkEventButton*);
    void show_fractal();
    void save_fractal();
    void show_fractal_light();
    void show_fractal_config();
    
};



class list_windowitem : public Gtk_ListItem {

private:


public:

    fractal_State fs;
    class list_window * lw;
    list_windowitem() {
      	connect_to_method(button_press_event, this, &list_windowitem::press);
    }
    
    gint button_press_event_impl(GdkEventButton * e) {
//  	printf("fuck\n");
	if(e->button != 3)
	    Gtk_ListItem::button_press_event_impl(e);
    }

    void load(const char * file) {
	fs.load(file);		       
	Gtk_Label * label = new Gtk_Label(fs.name);
	add(label);
	label->show();
    }

    void deselect_impl() {
 	lw->selected_state = 0;
	Gtk_ListItem::deselect_impl();
    }
    
    void select_impl() {
	printf("select_impl\n");
 	lw->selected_state = &fs;
	Gtk_ListItem::select_impl();
    }
    
    int press(GdkEventButton * f) {
	if(f->button == 3)
	    gtk_menu_popup(lw->menu, 0, 0, 0, 0, 0, 0);
    }
};


#endif
