#ifndef POSITIONER_H
#define POSITIONER_H

#include "radial_positioner.h"
#include "state.h"

class Positioner : public Gtk_RadialPositioner {
public:

    class State : public ::State {

    public:

	Positioner * pos;
	bool pushed;
	double xpos, ypos;

	State(): pos(0) {}

	void save(FILE * fp) {
	    fprintf(fp, "%d %.5f %.5f\n", pushed, xpos, ypos);
	}
	void load(FILE * fp) {
	    fscanf(fp, " %d %f %f ", &pushed, &xpos, &ypos);
	}
	double getx() { return(pos ? pos->getx() : xpos); }
	double gety() { return(pos ? pos->gety() : ypos); }

	void apply() {
	    pos->Gtk_RadialPositioner::set(xpos,ypos);
	    pos->Gtk_RadialPositioner::draw_position();
	}
	void grab() { xpos = pos->getx(); ypos = pos->gety(); }
	bool operator !=(State & other) {
	    return(xpos != other.xpos ||
		   ypos != other.ypos ||
		   pushed != other.pushed);
	}
    };
    
    Positioner(int x, int y): Gtk_RadialPositioner(x,y) {}
	
};
#endif
