/*
 *  quat.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "quat.h"

quat::quat() {
    s = 1;
    a = b = c = 0;
}

quat::quat(double _s, double _a, double _b, double _c) {
    s = _s;
    a = _a;
    b = _b;
    c = _c;
}

quat::quat(quat * q) {
    s = q->s;
    a = q->a;
    b = q->b;
    c = q->c;
}

double quat::mag() {		// returns mag^2
    return(s*s+a*a+b*b+c*c);
}

void quat::dump() {
  printf("[%.5f %.5f %.5f %.5f]", s, a, b, c);
}

