/*
 *  quat.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef QUAT_H
#define QUAT_H

#include <stdio.h>

class quat {

private: 

public:

    double s, a, b, c;
    
    quat();
    quat(double, double, double, double);
    quat(quat *);

    double mag();
    void dump();		// prints quat 
    void set(double _s, double _a, double _b, double _c) {
	s = _s;
	a = _a;
	b = _b;
	c = _c;
    }
    void operator =(quat & q) {
	s = q.s;
	a = q.a;
	b = q.b;
	c = q.c;
    }
    void operator =(double q[4]) {
	s = q[0];
	a = q[1];
	b = q[2];
	c = q[3];
    }
    bool operator ==(quat & q) {
	return(s==q.s&&a==q.a&&b==q.b&&c==q.c);
    }
    bool operator ==(double q[4]) {
	return(s==q[0]&&a==q[1]&&b==q[2]&&c==q[3]);
    }
    void load(FILE * fp) {
	fscanf(fp, " %f %f %f %f ", s, a, b, c);
    }
    void save(FILE * fp) {
	fprintf(fp, "%.5f %.5f %.5f %.5f\n", s, a, b, c);
    }
    bool eql(quat * q) {
	return s==q->s && a==q->a && b==q->b && c==q->c;
    }
};


#endif
