/*
 *  radial_positioner.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef RADIAL_POSITIONER_H
#define RADIAL_POSITIONER_H

#include <gtk--.h>
#include <gdk/gdk.h>
#ifdef USE_THREADS
#include <semaphore.h>
#endif

class Gtk_RadialPositioner : public Gtk_DrawingArea {

private:

    double xdisp, ydisp;	// screen display angles
    double xrot, yrot;		// actual values

    bool reversed;		// is mark in front or back?
    bool prev_in;		// was the last motion in or out?
    bool drag;			// are we dragging?

    handle_events(GdkEvent *);

    void draw_frame();		
#ifdef USE_THREADS
    sem_t mutex;
#endif

public:

    Signal0 changed;

    Gtk_RadialPositioner();
    Gtk_RadialPositioner(int, int);
    double getx();
    double gety();
    void setx(double);
    void sety(double);
    void fuck(double, double);
    void set(double x, double y); // moves positioner
    void draw_position();	// draws position arcs 
};


#endif
