#include "state.h"
#include <stdio.h>

void State::apply() {
    for(State::List * listptr = children ; listptr ; listptr = listptr->next) 
	listptr->state->apply();
}

void State::grab() {
    for(State::List * listptr = children ; listptr ; listptr = listptr->next) 
	listptr->state->grab();
}

void State::load(FILE * fp) {
    for(State::List * listptr = children ; listptr ; listptr = listptr->next) 
	listptr->state->load(fp);
}

void State::save(FILE * fp) {
    for(State::List * listptr = children ; listptr ; listptr = listptr->next) 
	listptr->state->save(fp);
}

void State::set_default() {
    for(State::List * listptr = children ; listptr ; listptr = listptr->next) 
	listptr->state->set_default();
}

void State::add_child(State * child) {
    State::List * new_child = new State::List;
    new_child->state = child;
    new_child->next = children;
    children = new_child;
}
