/*
 *  state.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef STATE_H
#define STATE_H

#include <stdio.h>

class State {
    
protected:

    class List {
	
    public:
	
	State * state;
	List * next;
    };

    List * children;
    void add_child(State * child);

public:

    virtual void apply();
    virtual void grab();
    virtual void load(FILE *);
    virtual void save(FILE *);
    virtual void set_default();

    State(): children(0) {}
};

#endif
