/*
 *  view_window.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef VIEW_WINDOW_H
#define VIEW_WINDOW_H

#include <gtk--.h>

#include "fract_view.h"
#include "light.h"
#include "fract_rot.h"
#include "combo.h"
#include "view_window_state.h"

class view_window : public Gtk_Window {

private:

    Gtk_OptionMenu * state_options;
    Gtk_Menu * state_menu;
    Gtk_VBox * top_box;
    Gtk_HBox * button_box;
    Gtk_Button * dismiss_button;
    Gtk_Button * revert_button;

    Gtk_Notebook * notebook;
    Fract_View * view;
    Light * light;
    Fract_Rot * model;

public:

    class view_window_State * state;

    void append_fractal(class fractal_State *);
    view_window(class view_window_State *);
    void revert();
    void attach_signals(Signal0 *);

};
#endif
